"use strict";

exports.__esModule = true;
exports.fromTaggedTemplateExpression = exports.fromCallExpression = void 0;

var _core = require("@babel/core");

var getCalleeAndStages = function getCalleeAndStages(_ref) {
  var callee = _ref.callee,
      args = _ref.arguments;
  return _core.types.isCallExpression(callee) ? [].concat(getCalleeAndStages(callee), [args]) : [callee, args];
};

var fromCallExpression = function fromCallExpression(expression) {
  var _getCalleeAndStages = getCalleeAndStages(expression),
      callee = _getCalleeAndStages[0],
      stages = _getCalleeAndStages.slice(1);

  return [callee, _core.types.arrayExpression(stages.map(function (stage) {
    return _core.types.arrayExpression(stage);
  }))];
};

exports.fromCallExpression = fromCallExpression;

var fromTaggedTemplateExpression = function fromTaggedTemplateExpression(expression, X) {
  var tag = expression.tag,
      quasi = expression.quasi;
  var quasis = quasi.quasis,
      expressions = quasi.expressions;

  var _ref2 = _core.types.isCallExpression(tag) ? fromCallExpression(tag) : [tag, false],
      callee = _ref2[0],
      STAGES = _ref2[1];

  var QUASI = _core.types.arrayExpression([_core.types.arrayExpression(quasis.map(function (_ref3) {
    var value = _ref3.value;
    return _core.types.stringLiteral(value.raw);
  }))].concat(expressions.length ? [_core.types.arrayExpression(expressions)] : []));

  return [callee, STAGES || X, QUASI];
};

exports.fromTaggedTemplateExpression = fromTaggedTemplateExpression;